/***************************************************************************
 *   Copyright (C) 2004 by Veselin Georgiev                                *
 *   vesko@ViruS                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "MyGlobal.h"
#include "MyTypes.h"
#include "sphere.h"

#define vfabs(x) (((x)<0)?-(x):(x))
#define FONT_XSIZE 10.66666666666
#define FONT_YSIZE 18
#define FONT_XSIZE_FLOOR 10
#define FONT_XSIZE_CEIL (FONT_XSIZE_FLOOR+1)


 // this should be 1/22
 #define LIGHTCONST 0.045454545455
 #define __1_22 LIGHTCONST

 // a resolution is accepted if the number of columns is a multiple of eight.
 #define RESOLUTION_X_ALIGN 8

#ifdef ACTUALLYDISPLAY
 void Slock(SDL_Surface *screen);
 void Sulock(SDL_Surface *screen);
 void PasteRaw(SDL_Surface *p, RawImg a, int x, int y);
 void intro_progress(SDL_Surface *p, double prog);
 void printxy(SDL_Surface *p, Uint32 *a, RawImg font, int x, int y, Uint32 col, float opacity, const char *buf, ...);
#endif

 int xres(void);
 int yres(void);
 void SetNewMode(int x, int y);
 void gfx_update_2nds(void);
 void DrawPixel(Uint32 *p, int x, int y, Uint8 r, Uint8 g, Uint8 b);
 void DrawPixeld(Uint32 *p, int x, int y, Uint32 v);
 Uint32 GetPixeld(Uint32 *p, int x, int y);
 void DrawTransparent(Uint32 *p, int x, int y, Uint32 col, float alpha);
 void wLine(Uint32 *p, int x1, int y1, int x2, int y2, Uint32 col);
 Uint32 multiplycolor(Uint32 color, int amp);
 Uint32 multiplycolorf(Uint32 color, float amp);
 Uint32 desaturate(Uint32 color, double factor);
 Uint32 blend(Uint32 foreground, Uint32 background, float opacity);
 Uint32 blend_sse(Uint32 foreground, Uint32 background, float opacity);
 Uint32 blend_p5(Uint32 foreground, Uint32 background, float opacity);
 float lightformulae_tiny(float x);
 int projectIt(sphere *a, double pt[][3], int *ns, Uint32 *fb, double *cur, double w[3][3], int xres, int yres, int color);
 void gfx_init (void);
 void gfx_close(void);
