/***************************************************************************
 *   Copyright (C) 2004 by Veselin Georgiev                                *
 *   vesko@ViruS                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

//#define FPS_COLOR 0xfe4bef
#define FPS_COLOR 0x23ea90
#define SHADOW_QUEUE_SIZE 8192
#define qmod (SHADOW_QUEUE_SIZE-1)
#define QSENTINEL -200

#define S_SPNUM_MASK		0x7F00
#define S_UPPER_MASK		0xFF00
#define S_MAX_BLACK		0x007F
#define S_COLOR_MASK		0x00FF
#define S_COLOR_BITS		7

// if the most significant bit in a word in the sbuffer is set, then the pixel contains blended data from two shadows
#define S_MIXED_MASK		0x8000

#define S_SPNUM_MODULUS		0x7f
#define S_SPNUM_OFFSET		8

// this controls the "smoothness" of the shadow edges
#define S_EDGE 0.5f
#define S_DEFAULT_OPACITY 0.2

// lower value = less bugs
#define CANDIDATE_INTERVAL	4

#define MAX_CPU_COUNT 64

#define THREAD_RUN_CMD 		1
#define THREAD_QUIT_CMD 	2

#include "MyGlobal.h"

#ifdef ACTUALLYDISPLAY
void render_single_frame(SDL_Surface *p, SDL_Overlay *ov);
#else
void render_single_frame(void);
#endif

// nearest doesn't need the fractional part...
Uint32 texture_handle_nearest (int x, int y);
Uint32 texture_handle_bilinear(double x, double y);
void move_camera(double angle);
void rotate_camera(double alphai, double betai);
void check_params(void);
Uint32 *get_image_buffer(void);

void set_cpus(int cpu_count);
void thread_init(void);
void thread_main(double *t0, double *ti, double *tti, int xr, int yr, Uint32 *ptr);
void render_close(void);

#ifdef _MSC_VER
double log2(double x);
#endif
