/***************************************************************************
 *   Copyright (C) 2004 by Veselin Georgiev                                *
 *   vesko@ViruS                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#define APPLY_X		1
#define APPLY_Y		2
#define APPLY_Z		4
#define APPLY_ALL	(APPLY_X|APPLY_Y|APPLY_Z)

#define RAYTRACE_BILINEAR_MASK 0x10000
#define MOVING_THRESH 0.0001

void r0tate(double *c, double alpha, double beta);
void r0tate2d(double *x, double *y, double angle);
void calc_grid_basics(double *c, double alpha, double beta, double w[3][3]);
int  ProjectSphere(sphere *a, double *cur, double w[3][3], int *dx, int *dy, int xres, int yres);
int  ProjectPoint(int *dx, int *dy, double *d, double *cur, double w[3][3], int xres, int yres);
int  ProjectSphereShadow(sphere *s, double *l, int *x_2d, int *y_2d, int xres, int yres, double *cur, double *tt, double *a, double *b);
void norm(double *a);
//int testsphere(sphere *a, double *v, double *cur);
int testsphere1(sphere *a, double *v, double *cur, double A, double *determinant, double *gB);
Uint32 Solve3D(sphere *a, double *v, double *c, double *l, double Arcp, float *opacity, double *determinant, double *gB, int iteration);
Uint32 Raytrace(double *src, double *v, int recursive, int iteration, sphere *last_sphere);
void PassPre(double *p, double plc, double *LL);
void apply_gravity(sphere *a, double t);
void apply_air(sphere *a, double t, int mask, int dir);
void advance(sphere *a, double t);
void check_moving(void);
int can_collide(int i, int j);
double collide (sphere *a, sphere *b, double btm);
void ProcessIncident(sphere *a, sphere *b, double t);

void set_gravity(double new_gravity);
void switch_gravity(void);
//void modify(int which, double amount);
void vectormath_close(void);

